<template>
  <div>
    <Modal v-model="showModal" width="900">
      <p slot="header">
        {{ modalTitle }}
      </p>
      <div>
        <!--内容-->
        <Row>
          <!--查询-->
          <Col span="24">
          <Form id="search-sample-company" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
            <label class="label-sign"></label>
            <Form-item label="文件名称:" class="search-item">
              <Input v-model="formObj.fileName" @on-enter="_formSearch" placeholder="请输入文件名" clearable />
            </Form-item>
            <Form-item class="search-btn">
              <Button @click="_formSearch" type="primary">
                搜索
              </Button>
            </Form-item>
          </Form>
          </Col>
          <!--操作-->
          <Col span="24">
          <btn-list :msg="btn" :open="searchOpen" @on-result-change="_btnClick" class="contHide" show-search-btn="true"></btn-list>
          </Col>
          <!-- 表格 -->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg"  @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
              <template slot-scope="scope">
                <div v-if="item.date">
                  {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):'' }}
                </div>
                <div v-else>
                  {{ scope.row[item.key] }}
                </div>
              </template>
            </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>
  </div>
</template>
<script>
import { soilEntrust, soilStatistics } from '../../../api'
import global from '../../../api/config'
export default {
  components: {},
  data() {
    return {
      formId: 'SampleItemManage',
      currentComponent: '',
      btn: [],
      iconMsg: [
        { type: 'ios-book', id: '', name: '预览' },
        { type: 'ios-download', id: '', name: '下载' },
        { type: 'md-trash', id: '', name: '删除' }
      ],
      sampleId: '', // 样品id
      entrustId: '',
      showModal: false,
      modalTitle: '查看附件',
      selectIds: [],
      itemId: '',
      index: '',
      showOption: true,
      searchOpen: true,
      selectData: {},
      getPage: {},
      currentRow: '',
      currentIndex: '',
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '关闭', type: 'primary' }
      ],
      pageColumns: [
        { title: '文件名', key: 'fileName' },
        { title: '类型', key: 'type', width: 120 },
        { title: '上传时间', key: 'ctime', width: 140, date: true }
      ],
      dateList: [],
      formObj: {
        fileName: undefined
      }
    }
  },
  computed: {
    tableHeight: function() {
      return this.$tableHeight('tableModal')
    }
  },
  methods: {
    _selectjudgeBasis(id, index) {
      console.log(id)
      this.itemId = id
      this.index = index
      this.$refs.EditModal._open()
    },
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '关闭':
          this._cancel()
          break
      }
    },
    _cancel() {
      this.$emit('on-result-change')
      this.$refs.pageTable._hideLoading()
      this.$refs.footerModal._hideLoading()
      this.showModal = false
    },
    _ok() {
      console.log(this.getPage.records)
    },
    _modalResult(data1, data2) {
      switch (this.currentComponent) {
        case 'CopyModal':
          if (data1 === 0) {
            this._copySample(data2)
          } else {
            this._copyAll(data2)
          }
          break
        default:
          this._search()
      }
    },
    _handleRow(data) {
      this.currentRow = data.row
      this.currentIndex = data.rowIndex
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '导入检测项目包':
            this._importItemPackage()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _iconClick(res, data, componentName, index) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '预览':
            this._viewReport(data)
            break
          case '下载':
            this._download(data)
            break
          case '删除':
            console.log(index)
            this._deleteById(data.id)
            break
        }
      })
    },
    _viewReport(data) {
      console.log(navigator.platform)
      if (this.$platform()) {
        // eslint-disable-next-line no-undef
        POBrowser.openWindowModeless(
          global.baseURL + '/print/v1/view_attachment?key=' + data.objectKey,
          'width=1163px;height=850px;'
        )
      } else {
        this.$Message.warning('暂不支持预览')
      }
    },
    // 下载
    _download(data) {
      console.log(data)
      this.$Modal.confirm({
        title: '提示',
        content: '确定要下载文件？',
        onOk: () => {
          window.open(
            global.baseURL + '/soil/v1/standard_annex/download/' + data.id,
            '_blank'
          )
        }
      })
    },
    _tableResultChange(msg, data) {
      const selectIds = []
      switch (msg) {
        case 'selectData':
          for (let i = 0; i < data.length; i++) {
            selectIds.push(data[i].id)
          }
          this.selectIds = selectIds
          this.selectData = data
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'page':
          this._page()
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _open(id) {
      this.formObj = this.$resetFields(this.formObj)
      this.dateList = []
      this.showModal = true
      this.entrustId = id // 委托id
      this.$refs.pageTable._hideLoading()
      this._page()
    },
    _openByEntrustId(id) {
      this.formObj = this.$resetFields(this.formObj)
      this.dateList = []
      this.showModal = true
      this.entrustId = id // 委托id
      this.$refs.pageTable._hideLoading()
      this._pageByEntrustId()
    },
    _openRecord(id) {
      this.formObj = this.$resetFields(this.formObj)
      this.dateList = []
      this.showModal = true
      this.sampleId = id // 委托id
      this.$refs.pageTable._hideLoading()
      this.showOption = false
      this._page()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _pageByEntrustId: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      this.formObj = this.$serializeForm(this.formObj)
      this.formObj.entrustId = this.entrustId
      const result = await soilEntrust.pageItemByEntrustId(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
        console.log(result)
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      this.formObj = this.$serializeForm(this.formObj)
      this.formObj.entrustId = this.entrustId
      const result = await soilStatistics.filePage(
        this.$serializeForm(this.formObj)
      )
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
        console.log(result)
      }
    },
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._deleteOk(ids)
        }
      })
    },

    _deleteOk: async function(ids) {
      const result = await soilEntrust.standardAnnexDelete(ids)
      if (result) {
        this._resultChange('删除成功！ ')
      }
    },
    _deleteById(id) {
      // 删除一条记录
      this._deleteByIds([id])
    },
    _deleteSelected() {
      // 批量删除
      const ids = this.selectIds
      if (ids.length === 0) {
        this.$Message.warning('请选择一条或多条数据！')
      } else {
        this._deleteByIds(ids, '确定删除 ' + ids.length + ' 条记录？')
      }
    },
    _detailModal(data) {},
    _editModal(edit, data) {
      if (edit) {
        console.log(data)
        this.$refs.sampleManageEdit._open(data)
      } else {
        // 添加
        this.$refs.refModal._open('', this.sampleId)
      }
    },
    // 添加编辑模拟样品
    _editImitateModal(edit, data) {
      if (edit) {
        // 模拟样品的编辑
        const tempData = JSON.parse(JSON.stringify(data)) // 深拷贝
        this.$refs.imitateModal._open(tempData, this.sampleId)
      } else {
        // 模拟样品的添加
        this.$refs.imitateModal._open('', this.sampleId)
      }
    },
    _search() {
      this._page()
    },
    _resultChange(msg) {
      this._page()
      this.$Message.success(msg)
      this.$emit('on-result-change')
    },
    // 导入检测项目
    _importItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(
          this.selectIds,
          this.selectData[0],
          this.selectData
        )
      }
    },
    // 导入检测项目包
    _importItemPackage() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds, 'sample-rel-package-item')
      }
    },
    _copyHisItem() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请至少选中一条样品数据！')
      } else {
        this.$refs.refModal._open(this.selectIds)
      }
    },
    _operationRecord(id) {
      // 操作日志
      this.$refs.recordModal._open(id)
    }
  }
}
</script>
